#ifndef _CX25874_H_
#define _CX25874_H_

typedef struct _i2c_write_byte_info {
	unsigned char id;
	unsigned char addr;
	unsigned char data;
} I2C_WRITE_BYTE_INFO;

typedef struct _i2c_read_byte_info {
	unsigned char id;
	unsigned char addr;
	unsigned char *pdata;
} I2C_READ_BYTE_INFO;

/* CX25874 & I2C IOCTL Commands */
#define CX25874_I2C_WRITE_BYTE	_IOW('v', 0x00, I2C_WRITE_BYTE_INFO)
#define CX25874_I2C_READ_BYTE	_IOW('v', 0x01, I2C_READ_BYTE_INFO)
#define IOCTL_CX25874_DISPLAY_MODE_SET	_IOW('v', 0x02, unsigned char)

#define CX25874_ID 	0x8A

#define DISPLAY_LCD 0x1
#define DISPLAY_MONITOR 0x2
#define DISPLAY_TV 0x3

#endif	// _CX25874_H_
