#ifndef _MMSP2_IF_H_
#define _MMSP2_IF_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include "dualcpu.h"
#include "vpp.h"
#include "cx25874.h"
#include "timer.h"

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned long long uint64;

/* see taiwan include/asm/arch/hardware.h
 * #define PA_BUFFER_BASE       0x02000000
 *
 * 16 ް  frame  start address, ý ޸ offset 32M 16ް 
 */
#define CODEC_BUFF_ADDR 0x02000000

// dualcpu: misc device 254 -> mknod /dev/dualcpu c 10 254
// vpp    : misc device 253 -> mknod /dev/vpp c 10 253
// cx25874: misc device
#define PATH_DEV_DUALCPU              "/dev/dualcpu"
#define PATH_DEV_DUALCPU_WITH_DEVFS   "/dev/misc/dualcpu"
                                                            // kernel devfs Ҷ
#define PATH_DEV_VPP                  "/dev/vpp"
#define PATH_DEV_VPP_WITH_DEVFS       "/dev/misc/vpp"

#define PATH_DEV_CX25874                  "/dev/cx25874"
#define PATH_DEV_CX25874_WITH_DEVFS       "/dev/misc/cx25874"

//  ִ width height, ̰ y_offset, cb_offset, cr_offset   .
//   ִ ũ⸦ ġ ̰Ͱ õ decode buffer 2D offset  Ѵ.
#define MAX_WIDTH  1024
#define MAX_HEIGHT 512

#define LCD_WIDTH 	320
#define LCD_HEIGHT 	240

#define TV_NTSC_ENC_WIDTH 	670		// display size
#define TV_NTSC_ENC_HEIGHT 	(232*2)
#define TV_PAL_ENC_WIDTH 	670		// display size
#define TV_PAL_ENC_HEIGHT 	(280*2)

extern unsigned char  *dbuf;           // compressed frame data buffer,  迭, ring q  ʴ´. 20050225 ghcstop
extern MP4D_DISPLAY_PARAM mp4d_disp;   // get status 940 register & decode output variable
extern int dbufsize;

/* function define */
int mmsp2_940_interface_buffer_init(void);
int mmsp2_setup_940_interface_buffer(int width, int height, unsigned int vformat_fourcc);
void mmsp2_release_codec(void);
int open_dualcpu_vpp(void);
void close_dualcpu_vpp_unmap(void);
int read_mp4d_940_status(MP4D_DISPLAY_PARAM * mp4d_940);
int set_FDC_YUVB_plane(int width, int height);

int run_940_decoder(unsigned long bufaddr, unsigned long bufsize);
int run_940_decoder_onlyrun(void);
void run_FDC_and_display();

#endif /* #ifndef _MMSP2_IF_H_ */
